#ifdef STRINGBUFPRIVATE

#ifndef CHART
#error CHART not defined
#endif
#ifndef CLASS
#error CLASS not defined
#endif

streampos CLASS::pos()
{
  return pos_;
}

int CLASS::get()
{
  if(pos_<str_.size())
    return str_[pos_++];
  return SBEOF;
}

int CLASS::put(const int c)
{
  str_+=static_cast<char>(c);
  return 0;
}
  
int CLASS::seek(const streamoff offs, const ios_base::seek_dir flag)
{
  int o=offs;
  switch(flag)
  {
  case ios_base::cur:
    o+=pos_;
    // no break here
  case ios_base::beg:
    if(o<0)
      o=0;
    else if(o>static_cast<int>(str_.size()))
      o=str_.size();
    break;

  case ios_base::end:
    if(o>0)
      o=0;
    o=pos_-o;
    if(o<0)
      o=0;
    break;

  default:
    return SBEOF;
  }
  pos_=o;
  return 0;
}

int CLASS::flush()
{
  return 0;
}

#endif
